/*******************************************************************************
 *  Copyright 2017-2018 Centre for Development of Advanced Computing(C-DAC), Pune
 *  
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *  
 *   http://www.apache.org/licenses/LICENSE-2.0
 *  
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 *******************************************************************************/
package cdac.medinfo.sdk.dcm30_04.templates.cid;


import cdac.medinfo.sdk.dcm30_04.templates.dicomsnomedmap.EnumDICOMSNOMEDMap;
import cdac.medinfo.sdk.dcm30_04.templates.enums.EnumCodingSchemeDesignator;
import cdac.medinfo.sdk.dcm30_04.templates.enums.EnumCodingSchemeVersion;
import cdac.medinfo.sdk.dcm30_04.templates.enums.cm.EnumCM_CharacteristicsOfMarginFromBI_RADS;
import cdac.medinfo.sdk.dcm30_04.templates.enums.cv.EnumCV_CharacteristicsOfMarginFromBI_RADS;


/**
 * This class represents CharacteristicsOfMarginFromBI - RADS_CID6007
 */
public class CharacteristicsOfMarginFromBI_RADS_CID6007 
{
	
	/**
	 * The Code Value for template.
	 */
	private String strCodeValue = null;

	/**
	 * The Code Meaning for template.
	 */
	private String strCodeMeaning = null;

	/**
	 * The Coding Scheme Designator for template.
	 */
	private String strCodingSchemeDesignator;
	
	/**
	 * The Coding Scheme Version
	 */
	private String strCodingSchemeVersion = null;
	/**
	 * The SNOMED CT ID for template.
	 */
	private String strSNOMEDCTID = null;
	/**
	 * Instantiates a new CharacteristicsOfMarginFromBI_RADS_CID6007 Template 
	 */
	public CharacteristicsOfMarginFromBI_RADS_CID6007()
	{

	}

	/**
	 * Retrieves the value for Code Meaning.
	 * @return String value for Code Meaning.
	 */
	public String getCodeMeaning()
	{
		return strCodeMeaning;
	}

	/**
	 * Retrieves the value for Code Value.
	 * @return String value for Code Value.
	 */
	public String getCodeValue() 
	{
		return strCodeValue;
	}

	/**
	 * Retrieves the value for Coding Scheme Designator.
	 * @return String value for Coding Scheme Designator.
	 */
	public String getCodingSchemeDesignator() 
	{
		return strCodingSchemeDesignator;
	}

	/**
	 * Retrieves the value for CodingSchemeVersion
	 * @return
	 */
	public String getCodingSchemeVersion() {
		return strCodingSchemeVersion;
	}
	/**
	 * Retrieves the value for SNOMED-CT ID.
	 * @return String value for SNOMED-CT ID.
	 */
	public String getSNOMEDCTID() 
	{
		return strSNOMEDCTID;
	}
	/**
	 * Sets the Code Value according to Code Meaning.
	 * @param enumCharacteristicsOfMarginFromBI_RADS Object of EnumCM_CharacteristicsOfMarginFromBI_RADS represents Code Meaning.
	 */
	private void setCodeValue(EnumCM_CharacteristicsOfMarginFromBI_RADS enumCharacteristicsOfMarginFromBI_RADS)
	{
		switch(enumCharacteristicsOfMarginFromBI_RADS)
		{
		case CIRCUMSCRIBED_LESION: this.strCodeValue = EnumCV_CharacteristicsOfMarginFromBI_RADS.CIRCUMSCRIBED_LESION_F_01741.getValue();break;
		case MICROLOBULATED_LESION: this.strCodeValue = EnumCV_CharacteristicsOfMarginFromBI_RADS.MICROLOBULATED_LESION_F_01742.getValue();break;
		case OBSCURED_LESION: this.strCodeValue = EnumCV_CharacteristicsOfMarginFromBI_RADS.OBSCURED_LESION_F_01743.getValue();break;
		case INDISTINCT_LESION: this.strCodeValue = EnumCV_CharacteristicsOfMarginFromBI_RADS.INDISTINCT_LESION_F_01744.getValue();break;
		case SPICULATED_LESION: this.strCodeValue = EnumCV_CharacteristicsOfMarginFromBI_RADS.SPICULATED_LESION_F_01745.getValue();break;
		case ANGULAR_MARGINS: this.strCodeValue =EnumCV_CharacteristicsOfMarginFromBI_RADS.ANGULAR_MARGINS_111343.getValue(); break;
		}
	}
	/**
	 * Sets the SNOMED-CT ID.
	 * @param enumCharacteristicsOfMarginFromBIRADS Object of EnumCM_CharacteristicsOfMarginFromBIRADS represents Code Meaning.
	 */
	private void setSNOMEDCTID(EnumCM_CharacteristicsOfMarginFromBI_RADS  enumCharacteristicsOfMarginFromBIRADS)
	{
		switch(enumCharacteristicsOfMarginFromBIRADS)
		{
		case CIRCUMSCRIBED_LESION : this.strSNOMEDCTID =EnumDICOMSNOMEDMap.CIRCUMSCRIBED_LESION.getSNOMEDCTID(); break;
		case MICROLOBULATED_LESION : this.strSNOMEDCTID =EnumDICOMSNOMEDMap.MICROLOBULATED_LESION.getSNOMEDCTID(); break;
		case OBSCURED_LESION : this.strSNOMEDCTID =EnumDICOMSNOMEDMap.OBSCURED_LESION.getSNOMEDCTID(); break;
		case INDISTINCT_LESION : this.strSNOMEDCTID =EnumDICOMSNOMEDMap.INDISTINCT_LESION.getSNOMEDCTID(); break;
		case SPICULATED_LESION : this.strSNOMEDCTID =EnumDICOMSNOMEDMap.SPICULATED_LESION.getSNOMEDCTID(); break;
			
		}
	}
	/**
	 * Sets the value for CharacteristicsOfMarginFromBI_RADS
	 * @param enumCharacteristicsOfMarginFromBI_RADS Object of EnumCM_CharacteristicsOfMarginFromBI_RADS.
	 */
	public void setCharacteristicsOfMarginFromBI_RADS(EnumCM_CharacteristicsOfMarginFromBI_RADS enumCharacteristicsOfMarginFromBI_RADS)
	{
		/**
		 * Retrieves the value for CodingSchemeDesignator, CodingSchemeVersion and Code Meaning and 
		 * sets the Code Value according to Code Meaning.
		 */
		this.strCodeMeaning = enumCharacteristicsOfMarginFromBI_RADS.getValue();
		if(strCodeMeaning.equalsIgnoreCase(EnumCM_CharacteristicsOfMarginFromBI_RADS.ANGULAR_MARGINS.getValue()))
			this.strCodingSchemeDesignator = EnumCodingSchemeDesignator.DCM.getValue();
		else
			this.strCodingSchemeDesignator = EnumCodingSchemeDesignator.SRT.getValue();

		/**
		 * set code Value
		 */
		setCodeValue(enumCharacteristicsOfMarginFromBI_RADS);
		
		/**
		 * set SNOMED-CT ID
		 */
		setSNOMEDCTID(enumCharacteristicsOfMarginFromBI_RADS);
	}
}
